﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace DirectX_CSharp_3
{

    public partial class Form1 : Form
    {
        private float RotateAngX, RotateAngY, RotateAngZ, PressButonX, PressButonY, PressButonZ;

        private Device device = null;
        private VertexBuffer vb = null;
        private Texture tex = null;
        private Texture tex1 = null;
        private Texture tex2 = null;



        /// <summary>
        /// We will initialize our graphics device here
        /// </summary>
        public void InitializeGraphics()
        {
            // Set our presentation parameters
            PresentParameters presentParams = new PresentParameters();

            presentParams.Windowed = true;
            presentParams.SwapEffect = SwapEffect.Discard;

            // Create our device
            device = new Device(0, DeviceType.Hardware, this, CreateFlags.SoftwareVertexProcessing, presentParams);

            vb = new VertexBuffer(typeof(CustomVertex.PositionTextured), 36, device, Usage.Dynamic
    | Usage.WriteOnly, CustomVertex.PositionTextured.Format, Pool.Default);

            vb.Created += new EventHandler(this.OnVertexBufferCreate);
            OnVertexBufferCreate(vb, null);


        }


        private void OnVertexBufferCreate(object sender, EventArgs e)
        {
            VertexBuffer buffer = (VertexBuffer)sender;

           CustomVertex.PositionTextured[] verts = new CustomVertex.PositionTextured[36];

            // Front face
            verts[0] = new CustomVertex.PositionTextured(-1.0f, 1.0f, 1.0f, 0.0f, 0.0f);
            verts[1] = new CustomVertex.PositionTextured(-1.0f, -1.0f, 1.0f, 0.0f, 1.0f);
            verts[2] = new CustomVertex.PositionTextured(1.0f, 1.0f, 1.0f, 1.0f, 0.0f);
            verts[3] = new CustomVertex.PositionTextured(-1.0f, -1.0f, 1.0f, 0.0f, 1.0f);
            verts[4] = new CustomVertex.PositionTextured(1.0f, -1.0f, 1.0f, 1.0f, 1.0f);
            verts[5] = new CustomVertex.PositionTextured(1.0f, 1.0f, 1.0f, 1.0f, 0.0f);

            // Back face (remember this is facing *away* from the camera, so vertices should be  clockwise order)
            verts[6] = new CustomVertex.PositionTextured(-1.0f, 1.0f, -1.0f, 0.0f, 0.0f);
            verts[7] = new CustomVertex.PositionTextured(1.0f, 1.0f, -1.0f, 1.0f, 0.0f);
            verts[8] = new CustomVertex.PositionTextured(-1.0f, -1.0f, -1.0f, 0.0f, 1.0f);
            verts[9] = new CustomVertex.PositionTextured(-1.0f, -1.0f, -1.0f, 0.0f, 1.0f);
            verts[10] = new CustomVertex.PositionTextured(1.0f, 1.0f, -1.0f, 1.0f, 0.0f);
            verts[11] = new CustomVertex.PositionTextured(1.0f, -1.0f, -1.0f, 1.0f, 1.0f);

            // Top face
            verts[12] = new CustomVertex.PositionTextured(-1.0f, 1.0f, 1.0f, 0.0f, 0.0f);
            verts[13] = new CustomVertex.PositionTextured(1.0f, 1.0f, -1.0f, 1.0f, 1.0f);
            verts[14] = new CustomVertex.PositionTextured(-1.0f, 1.0f, -1.0f, 0.0f, 1.0f);
            verts[15] = new CustomVertex.PositionTextured(-1.0f, 1.0f, 1.0f, 0.0f, 0.0f);
            verts[16] = new CustomVertex.PositionTextured(1.0f, 1.0f, 1.0f, 1.0f, 0.0f);
            verts[17] = new CustomVertex.PositionTextured(1.0f, 1.0f, -1.0f, 1.0f, 1.0f);

            // Bottom face (remember this is facing *away* from the camera, so vertices should be  clockwise order)
            verts[18] = new CustomVertex.PositionTextured(-1.0f, -1.0f, 1.0f, 0.0f, 0.0f);
            verts[19] = new CustomVertex.PositionTextured(-1.0f, -1.0f, -1.0f, 0.0f, 1.0f);
            verts[20] = new CustomVertex.PositionTextured(1.0f, -1.0f, -1.0f, 1.0f, 1.0f);
            verts[21] = new CustomVertex.PositionTextured(-1.0f, -1.0f, 1.0f, 0.0f, 0.0f);
            verts[22] = new CustomVertex.PositionTextured(1.0f, -1.0f, -1.0f, 1.0f, 1.0f);
            verts[23] = new CustomVertex.PositionTextured(1.0f, -1.0f, 1.0f, 1.0f, 0.0f);

            // Left face
            verts[24] = new CustomVertex.PositionTextured(-1.0f, 1.0f, 1.0f, 0.0f, 0.0f);
            verts[25] = new CustomVertex.PositionTextured(-1.0f, -1.0f, -1.0f, 1.0f, 1.0f);
            verts[26] = new CustomVertex.PositionTextured(-1.0f, -1.0f, 1.0f, 1.0f, 0.0f);
            verts[27] = new CustomVertex.PositionTextured(-1.0f, 1.0f, -1.0f, 0.0f, 1.0f);
            verts[28] = new CustomVertex.PositionTextured(-1.0f, -1.0f, -1.0f, 1.0f, 1.0f);
            verts[29] = new CustomVertex.PositionTextured(-1.0f, 1.0f, 1.0f, 0.0f, 0.0f);

            // Right face (remember this is facing *away* from the camera, so vertices should be   clockwise order)
            verts[30] = new CustomVertex.PositionTextured(1.0f, 1.0f, 1.0f, 0.0f, 0.0f);
            verts[31] = new CustomVertex.PositionTextured(1.0f, -1.0f, 1.0f, 1.0f, 0.0f);
            verts[32] = new CustomVertex.PositionTextured(1.0f, -1.0f, -1.0f, 1.0f, 1.0f);
            verts[33] = new CustomVertex.PositionTextured(1.0f, 1.0f, -1.0f, 0.0f, 1.0f);
            verts[34] = new CustomVertex.PositionTextured(1.0f, 1.0f, 1.0f, 0.0f, 0.0f);
            verts[35] = new CustomVertex.PositionTextured(1.0f, -1.0f, -1.0f, 1.0f, 1.0f);

            buffer.SetData(verts, 0, LockFlags.None);

            tex = new Texture(device, new Bitmap(this.GetType(), "puck.bmp"), 0, Pool.Managed);
            tex1 = new Texture(device, new Bitmap(this.GetType(), "banana.bmp"), 0, Pool.Managed);
            tex2 = new Texture(device, new Bitmap(this.GetType(), "ground.bmp"), 0, Pool.Managed);

            device.VertexFormat = CustomVertex.PositionTextured.Format;


        }


        private float angle=0;
        private void SetupCamera()
        {
            // Устанавливаем матрицу проецирования:
            device.Transform.Projection = Matrix.PerspectiveFovLH(
              (float)Math.PI / 4, ((float)Width) / Height, 0.5f, 100f);
            // Устанавливаем матрицу вида (положение и ориентация камеры):
            device.Transform.View = Matrix.LookAtLH(
              new Vector3(0, 0.5f, -20), new Vector3(0, 0, 0), new Vector3(0, 1, 0));
            
            //device.Transform.World = Matrix.RotationYawPitchRoll(RotateAngX / (float)Math.PI, RotateAngY /(float)Math.PI * 2.0f, 1 / (float)Math.PI);

            device.Transform.World = Matrix.RotationX(RotateAngX) * Matrix.RotationY(RotateAngY) * Matrix.RotationZ(RotateAngZ);
        }


        protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
        {
            device.Clear(ClearFlags.Target, System.Drawing.Color.CornflowerBlue, 1.0f, 0);//очищаемэкран голубым цветом
            device.RenderState.Lighting = false;//убираем освещение
         
            SetupCamera();//устанавливаем камеру
            //device.RenderState.CullMode = Cull.None;//отображает заднюю часть треугольника

            //здаем освещение
            
            device.Lights[0].Type = LightType.Point;
            device.Lights[0].Position = new Vector3();
            device.Lights[0].Diffuse = System.Drawing.Color.White;
            device.Lights[0].Attenuation0 = 0.2f;
            device.Lights[0].Range = 10000.0f;
            device.Lights[0].Enabled = true;
            

            device.BeginScene();//рисуем наш треугольник
            
  //          device.DrawUserPrimitives(PrimitiveType.TriangleList, 1, verts);

            device.SetStreamSource(0, vb, 0);
            //device.DrawPrimitives(PrimitiveType.TriangleList, 0, 12);
            
            // Draw our boxes
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI * 2.0f, angle / (float)Math.PI /
                4.0f, 0.0f, 0.0f, 0.0f, tex);
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI / 1.0f, angle / (float)Math.PI *
                4.0f, 5.0f, 0.0f, 0.0f, tex1);
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI * 0.5f, angle / (float)Math.PI /
                2.0f, -5.0f, 0.0f, 0.0f, tex2);
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI * 2.0f, angle / (float)Math.PI /
                4.0f, 0.0f, -5.0f, 0.0f, tex);
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI / 3.0f, angle / (float)Math.PI *
                4.0f, 5.0f, -5.0f, 0.0f, tex1);
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI * 4.0f, angle / (float)Math.PI /
                2.0f, -5.0f, -5.0f, 0.0f, tex2);
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI * 9.0f, angle / (float)Math.PI /
                4.0f, 0.0f, 5.0f, 0.0f, tex);
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI / 6.0f, angle / (float)Math.PI *
                4.0f, 5.0f, 5.0f, 0.0f, tex1);
            DrawBox(angle / (float)Math.PI, angle / (float)Math.PI * 4.0f, angle / (float)Math.PI /
                2.0f, -5.0f, 5.0f, 0.0f, tex2);


            device.EndScene();

            device.Present();

            this.Invalidate();//Перерисовка формы

            this.SetStyle(ControlStyles.AllPaintingInWmPaint | ControlStyles.Opaque, true);
        }

        private void DrawBox(float yaw, float pitch, float roll, float x, float y, float z,
        Texture t)
        {
            angle += 0.01f;

            device.Transform.World = Matrix.RotationYawPitchRoll(yaw, pitch, roll) *
                Matrix.Translation(x, y, z);
            device.SetTexture(0, t);
            device.DrawPrimitives(PrimitiveType.TriangleList, 0, 12);
        }


        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            //поворот объекта с помощью мыши
            if (e.Button.ToString() == "Left")
            {
                RotateAngY += (PressButonX - e.X)/100.0f;
                RotateAngX += (PressButonY - e.Y)/100.0f;

                Form1_MouseDown(sender, e);
            }
        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            PressButonX = e.X;
            PressButonY = e.Y;
        }


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            switch ((int)e.KeyCode)
            {
                case 37://на Лево
                    RotateAngX -= 0.1f;
                    break;
                case 38://вверх
                    RotateAngY += 0.1f;
                    break;
                case 39://на право
                    RotateAngX += 0.1f;
                    break;
                case 40://в низ
                    RotateAngY -= 0.1f;
                    break;
                case ((37) & (38))://на лево и вверх
                    RotateAngX -= 0.1f;
                    RotateAngY += 0.1f;
                    break;
            }
        }
    }
}
